<?php
/**
 * @package 
 * @version 1.0.6 
 * @author Jason Lau
 * @link http://jasonlau.biz
 * @copyright 2011
 * @license GNU/GPL 3+
 * @uses WordPress
 
Plugin Name: Visitor Maps Extended Referer Field
Plugin URI: http://jasonlau.biz
Description: This WordPress plugin extends and depends on the <a href="http://www.642weather.com/weather/scripts-wordpress-visitor-maps.php" target="_blank">Visitor Maps and Who's Online</a> plugin by <a title="Visit author homepage" href="http://www.642weather.com/weather/scripts.php" target="_blank">Mike Challis</a>. This plugin alters the <em>Referer</em> column for the Admin's <em>Who's Been Online</em> grid, so it displays the referring host name followed by the search string, if there is one. It also prevents long URLs from expanding the grid too wide for viewing. Additionally, you can ban and unban visitor IP addresses using a toggle button. Banned IP addresses are added to .htaccess, which is automatically backed-up before any changes are made. There are no settings required.
Author: Jason Lau
Version: 1.0.6
Author URI: http://jasonlau.biz
*/

if (realpath(__FILE__) == realpath($_SERVER['SCRIPT_FILENAME'])) {
    exit('Please don\'t access this file directly.');
}


function visitor_maps_extended_ref(){
    wp_enqueue_script('jquery');
    wp_register_script('visitor_maps_extended_referer', plugins_url('/visitor-maps-extended-referer-field/visitor-maps-extended-referer.js', dirname(__FILE__)));
    wp_enqueue_script('visitor_maps_extended_referer');
    vmerf_init();
}


function vmerf_init(){
    $banned_ips = get_option("vmerf_banned_ips");
    $vmerf_output = "<script type=\"text/javascript\">
	var vmerf_message = '', vmerf_ip = ''; vmerf_admin_ip = '" . $_SERVER["REMOTE_ADDR"] . "';\n";
        
   if($_POST['vmerf_mode'] && $_POST['vmerf_mode'] == 'ban'){
    
        $vmerf_output .= "var vmerf_mode = 'ban';\n";
        @copy(ABSPATH . ".htaccess", ABSPATH . ".htaccess.backup");
        $fp = @fopen(ABSPATH . ".htaccess", "a+");
        @fwrite($fp, "\ndeny from " . $_POST['vmerf_ip']);
        @fclose($fp);
        if($banned_ips != ''){
            update_option("vmerf_banned_ips", $banned_ips . ", " . $_POST['vmerf_ip']); 
        } else {
            update_option("vmerf_banned_ips", $_POST['vmerf_ip']);
        }
        
        $vmerf_output .= "vmerf_message += '" . $_POST['vmerf_ip'] . " successfully banned!';\n";
        $vmerf_output .= "vmerf_ip += '" . $_POST['vmerf_ip'] . "';\n";
               
    } else if($_POST['vmerf_mode'] && $_POST['vmerf_mode'] == 'unban'){
        
        $vmerf_output .= "var vmerf_mode = 'unban';\n";
        @copy(ABSPATH . ".htaccess", ABSPATH . ".htaccess.backup");
        vmerf_del_line_in_file(ABSPATH . ".htaccess", "deny from " . $_POST['vmerf_ip']);
        $ips = explode(", ", $banned_ips);
        $new_list = "";
        foreach($ips as $ip){
            if($ip != $_POST['vmerf_ip'] && $new_list == ""){
               $new_list .= $ip;
            } elseif($ip != $_POST['vmerf_ip']){
               $new_list .= ", " . $ip; 
            } 
        }
        update_option("vmerf_banned_ips", $new_list);
        $vmerf_output .= "vmerf_message += '" . $_POST['vmerf_ip'] . " successfully unbanned!';\n";
        $vmerf_output .= "vmerf_ip += '" . $_POST['vmerf_ip'] . "';\n";  
                 
    }
    
    $banned_ips = get_option("vmerf_banned_ips");
    $vmerf_output .= "var vmerf_banned_ips = '{$banned_ips}';
        vmerf_banned_ips = vmerf_banned_ips.split(', ')\n";
    
    $vmerf_output .= "</script>\n";
    
    echo $vmerf_output;
}

if(is_dir(plugin_dir_path('visitor-maps'))){
    add_action('admin_enqueue_scripts', 'visitor_maps_extended_ref'); 
}

function vmerf_del_line_in_file($filename, $text_to_delete){
  $file_array = array();	
  $file = fopen($filename, 'rt');
  if($file){
    while(!feof($file)){
      $val = fgets($file);
      if(is_string($val))
        array_push($file_array, $val);
    }	
    fclose($file);
  }
  for($i = 0; $i < count($file_array); $i++)
  {
    if(strstr($file_array[$i], $text_to_delete))
    {
      if($file_array[$i] == $text_to_delete . "\n") $file_array[$i] = '';
    }
  }
  $file_write = fopen($filename, 'wt');	
  if($file_write){
    fwrite($file_write, implode("", $file_array));
    fclose($file_write);
  }
}
?>